<?php
// $Id: rdf.pages.inc,v 1.4 2008/10/01 11:32:01 arto Exp $

//////////////////////////////////////////////////////////////////////////////
// Menu callbacks

function rdf_export_site() {
  $data = rdf_query(url(NULL, array('absolute' => TRUE)));
  rdf_export($data, 'site');
}

function rdf_export_entity($type, $id) {
  $data = rdf_query(url($type .'/'. $id, array('absolute' => TRUE)));
  rdf_export($data, implode('-', array($type, $id)));
}

function rdf_export($data, $filename = 'export', $format = RDF_FORMAT, $options = array()) {
  //module_load_include('inc', 'rdf_export', 'rdf_export');

  $formats = rdf_get_formats();
  $format = isset($formats[@$_GET['format']]) ? $_GET['format'] : $format;
  $format = $formats[$format];
  $filename = implode('.', array($filename, $format->file_ext));

  if (!empty($options['log'])) {
    watchdog('rdf', 'Exported RDF data file: %filename.', array('%filename' => $filename));
  }

  $output = rdf_serialize(is_string($data) ? $data() : $data, array('format' => $format->name));

  //$format->mime_type = 'text/plain'; // FIXME
  header('Content-Disposition: inline; filename='. $filename);
  header('Content-Type: '. $format->mime_type .'; charset='. $format->encoding);
  header('Content-Length: '. strlen($output));
  die($output);
}
